/*
 * DO NOT EDIT.  THIS FILE IS GENERATED FROM
 * nsIHttpServer.idl
 */

package org.mozilla.interfaces;

public interface nsIHttpResponse extends nsISupports {

  String NS_IHTTPRESPONSE_IID =
    "{a2aaaff7-03bd-43b6-b460-94671e288093}";

  /**
 * Represents an HTTP response, as described in RFC 2616, section 6.
 */
/**
   * Sets the status line for this.  If this method is never called on this, the
   * status line defaults to "HTTP/", followed by the server's default HTTP
   * version (e.g. "1.1"), followed by " 200 OK".
   *
   * @param httpVersion
   *   the HTTP version of this, as a string (e.g. "1.1"); if null, the server
   *   default is used
   * @param code
   *   the numeric HTTP status code for this
   * @param description
   *   a human-readable description of code; may be null if no description is
   *   desired
   * @throws NS_ERROR_INVALID_ARG
   *   if httpVersion is not a valid HTTP version string, statusCode is greater
   *   than 999, or description contains invalid characters
   */
  void setStatusLine(String httpVersion, int statusCode, String description);

  /**
   * Sets the specified header in this.
   *
   * @param name
   *   the name of the header; must match the field-name production per RFC 2616
   * @param value
   *   the value of the header; must match the field-value production per RFC
   *   2616
   * @param merge
   *   when true, if the given header already exists in this, the values passed
   *   to this function will be merged into the existing header, per RFC 2616
   *   header semantics; when false, if the given header already exists in this,
   *   it is overwritten with the passed-in values; if the header doesn't exist
   *   in this, it is set regardless of the value of this parameter
   * @throws NS_ERROR_INVALID_ARG
   *   if name or value is not a valid header component
   */
  void setHeader(String name, String value, boolean merge);

  /**
   * A stream to which data appearing in the body of this response should be
   * written.
   */
  nsIOutputStream getBodyOutputStream();

  /**
   * Write a string to the response's output stream.
   *
   * @note
   *   This method is only guaranteed to work with ASCII data.
   */
  void write(String data);

}